<?php

if ( !function_exists('is_indexed_array')) {
    /**
     * Test si un tableau est de type indexé
     *
     * @param array Le tableau à tester
     * @return bool
     */
    function is_indexed_array(array $array): bool
    {
        return array_keys($array) === range(0, count($array) - 1);
    }
}

if ( !function_exists('array_keys_exists')) {
    /**
     * Test si plusieurs clefs sont présentes dans un tableau
     *
     * @param array $keys
     * @param array $arr
     * @return boolean
     */
    function array_keys_exists(array $keys, array $arr): bool
    {
        return !array_diff_key(array_flip($keys), $arr);
    }
}

if ( !function_exists('array_contains')) {
    /**
     * Test si au moins un élément est présent dans un tableau
     *
     * @param array $keys
     * @param array $arr
     * @return boolean
     */
    function array_contains(array $keys, array $arr): bool
    {
        foreach ($keys as $key)  {
            if (in_array($key, $arr)) {
                return true;
            }
        }

        return false;
    }
}
